var noble = require('../index');


noble.on('stateChange', function(state) {
  if (state === 'poweredOn') {
    noble.startScanning();
  } else {
    noble.stopScanning();
  }
});

noble.on('discover', function(peripheral) {
  peripheral.connect(function(error) {
    console.log('connected to peripheral: ' + peripheral.uuid);
    peripheral.discoverServices(['ff10'], function(error, services) {
      var deviceInformationService = services[0];
      console.log('discovered device information service');

      deviceInformationService.discoverCharacteristics(['ff11'], function(error, characteristics) {
        var deviceCharacteristic = characteristics[0];
        console.log('discovered deviceCharacteristic');

        deviceCharacteristic.read(function(error, data) {
          // data is a buffer
          console.log('deviceCharacteristic value-read: ' + data.toString('hex'));
        });
        
        
        // *jwc: seems that not work if 'true', therefore use 'false': true if for write without response
        var writeBuffer = new Buffer(1);
        writeBuffer.writeUInt8(0x00, 0);
        // jwc good but too cryptic: deviceCharacteristic.write(new Buffer([0x01]), false, function(error) {
        deviceCharacteristic.write(writeBuffer, false, function(error) {
		if( error ){
		  console.log('>>> deviceCharacteristic.write: BAD');
		}
		else {
		  console.log('>>> deviceCharacteristic.write: GOOD');
		}

          console.log('deviceCharacteristic value-write: ' + writeBuffer.toString('hex'));
        });

        
      });
    });
  });
});
