var noble = require('../index');


noble.on('stateChange', function(state) {
  if (state === 'poweredOn') {
    noble.startScanning();
  } else {
    noble.stopScanning();
  }
});

noble.on('discover', function(peripheral) {
  peripheral.connect(function(error) {
    console.log('connected to peripheral: ' + peripheral.uuid);
    peripheral.discoverServices(['ff10'], function(error, services) {
      var deviceInformationService = services[0];
      console.log('discovered device information service');

      deviceInformationService.discoverCharacteristics(['ff11'], function(error, characteristics) {
        var deviceCharacteristic = characteristics[0];
        console.log('discovered deviceCharacteristic');

		var data_Read;
		
		deviceCharacteristic.read(function(error, data) {
          // data is a buffer
          console.log('deviceCharacteristic value-read: ' + data.toString('hex'));
 		
		  data_Read = data.toString('hex');
        });
        

		var writeBuffer = new Buffer(1);
		
		// Toggle the value just read in
		if( data_Read == '0x00' ){	
			writeBuffer.writeUInt8(0x01, 0);
			console.log('>>> data_Read == \'0x00\'');
		}
		else {
			writeBuffer.writeUInt8(0x01, 0);
			console.log('>>> data_Read == \'0x01\'');
		}
		
		// *jwc: seems that not work if 'true', therefore use 'false': true if for write without response
        // jwc good but too cryptic: deviceCharacteristic.write(new Buffer([0x01]), false, function(error) {
        deviceCharacteristic.write(writeBuffer, false, function(error) {
		if( error ){
		  console.log('>>> deviceCharacteristic.write: BAD');
		}
		else {
		  console.log('>>> deviceCharacteristic.write: GOOD');
		}

          console.log('deviceCharacteristic value-write: ' + writeBuffer.toString('hex'));
        });

        
      });
    });
  });
});
