var noble = require('../index');


noble.on('stateChange', function(state) {
  if (state === 'poweredOn') {
    noble.startScanning();
  } else {
    noble.stopScanning();
  }
});

noble.on('discover', function(peripheral) {
  peripheral.connect(function(error) {
    console.log('connected to peripheral: ' + peripheral.uuid);
    peripheral.discoverServices(['ff10'], function(error, services) {
      var deviceInformationService = services[0];
      console.log('discovered device information service');

      deviceInformationService.discoverCharacteristics(['ff11'], function(error, characteristics) {
        var deviceCharacteristic = characteristics[0];
        console.log('discovered deviceCharacteristic');

		var data_Read;
		
		deviceCharacteristic.read(function(error, data) {
          // data is a buffer
          console.log('1> deviceCharacteristic value-read: ' + data.toString('hex'));
 		
		  data_Read = data.toString('hex');
        
        
			var writeBuffer = new Buffer(1);
			
			// Toggle the value just read in
			////if( data_Read == '0x00' ){	
			if( data_Read == '00' ){	
				console.log('2> data_Read == \'00\'');
				writeBuffer.writeUInt8(0x01, 0);
			}
			else {
				console.log('2> data_Read == \'01\'');
				writeBuffer.writeUInt8(0x00, 0);
			}
			
			// *jwc: seems that not work if 'true', therefore use 'false': true if for write without response
			// jwc good but too cryptic: deviceCharacteristic.write(new Buffer([0x01]), false, function(error) {
			deviceCharacteristic.write(writeBuffer, false, function(error) {
			if( error ){
			  console.log('3> deviceCharacteristic value-write: BAD');
			}
			else {
			  console.log('3> deviceCharacteristic value-write: GOOD');
			}

			console.log('4> deviceCharacteristic value-write: ' + writeBuffer.toString('hex'));
			});

                
        
        });
        

        
      });
    });
  });
});
