var noble = require('../index');


noble.on('stateChange', function(state) {
  if (state === 'poweredOn') {
    noble.startScanning();
  } else {
    noble.stopScanning();
  }
});

noble.on('discover', function(peripheral) {
  peripheral.connect(function(error) {
    console.log('connected to peripheral: ' + peripheral.uuid);
    peripheral.discoverServices(['ff10'], function(error, services) {
      var deviceInformationService = services[0];
      console.log('discovered device information service');

      deviceInformationService.discoverCharacteristics(['ff11'], function(error, characteristics) {
        var deviceCharacteristic = characteristics[0];
        console.log('discovered deviceCharacteristic');

				deviceCharacteristic.read(function(error, readBuffer) {
					// readBuffer is a buffer
					var dataRead = readBuffer.toString('hex');					
					console.log('1> deviceCharacteristic value-read: ' + dataRead);
		
					var writeBuffer = new Buffer(1);

					// Toggle the value just read in
					////if( dataRead == '0x00' ){	
					if( dataRead == '00' ){	
						console.log('2> dataRead == \'00\'');
						writeBuffer.writeUInt8(0x01, 0);
					}
					else {
						console.log('2> dataRead == \'01\'');
						writeBuffer.writeUInt8(0x00, 0);
					}
					
					var dataWrite = writeBuffer.toString('hex');
					
					// jwc: seems that not work if 'true', therefore use 'false': true if for write without response
					// jwc good but too cryptic: deviceCharacteristic.write(new Buffer([0x01]), false, function(error) {
					deviceCharacteristic.write(writeBuffer, false, function(error) {
						if( error ){
							console.log('3> deviceCharacteristic value-write: BAD');
						}
						else {
							console.log('3> deviceCharacteristic value-write: GOOD');
						}

						console.log('4> deviceCharacteristic value-write: ' + dataWrite);
						console.log('');
					});
				
				
				});
    
        
      });
    });
  });
  
  peripheral.disconnect(function(error) {
    console.log('disconnected from peripheral: ' + peripheral.uuid);
  });
  
  
});
